Comment ajouter correctement un démon personnalisé à init.d?

25

J'ai un démon de serveur d’application propriétaire tiers qui peut être démarré et arrêté par deux lignes de commande. J'ai besoin que ce démon démarre lorsque le système démarre et s'arrête correctement à l'arrêt du système. Comment puis-je correctement implémenter cela? Est-il suffisant de copier un script dans /etc/init.d et de le modifier en conséquence?

    
posée Ivan 25.12.2010 - 09:01
la source

5 réponses

16

init.d est l'ancien système obsolète de démarrage des démons; Il a été remplacé par upstart . Upstart a l'avantage d'être beaucoup plus facile à configurer et permet un séquencement correct de l'initialisation des tâches.

Les fichiers de configuration pour upstart live dans / etc / init et si votre démon n'a pas de pré-requis, cela peut être aussi simple que tty1.conf:

# tty1 - getty
#
# This service maintains a getty on tty1 from the point the system is
# started until it is shut down again.

start on stopped rc RUNLEVEL=[2345]
stop on runlevel [!2345]

respawn
exec /sbin/getty -8 38400 tty1

Dans ce cas, vous pouvez copier ce fichier et le modifier au goût. Les configurations plus complexes sont mieux documentées sur le site de démarrage et dans les autres entrées de / etc / init.

ajouté en réponse au commentaire

Que vous utilisiez upstart ou init.d, vous aurez toujours besoin d’un moyen de déterminer à quel moment Firebird est correctement initialisé. Malheureusement, Firebird lui-même ne semble pas avoir un bon moyen de vérifier que il est installé et en cours d'exécution . Par conséquent, la recommandation de coller votre programme au démarrage dans /etc/rc.local est certainement la plus simple, et sous Ubuntu - au moins - est garanti de fonctionner le plus tard possible dans le processus de démarrage.

    
réponse donnée msw 25.12.2010 - 10:45
la source
12

si vous ne souhaitez pas migrer vers UPSTART, mais souhaitez l’approche classique, vous devez:

REMARQUE: je sauvegarde le service et le programme sous le même nom dans différents répertoires (mais vous pouvez les modifier, à condition que cela soit reflété dans votre fichier de service). changez "myscriptname" et "myprogramname" en vrais noms!

  1. enregistrez votre programme qui sera exécuté en tant que service dans / usr / sbin

    sudo cp myprogramname /usr/sbin/myscriptname

  2. créer un script de démarrage de base (utilisez /etc/init.d/skeleton comme référence)

  3. déplacez ce script vers /etc/init.d

    sudo mv /etc/init.d/myscriptname

  4. donnez à ce script la permission d’exécuter (j’ai utilisé 775, mais vous pouvez le définir plus bas)

    sudo chmod 755 /etc/init.d/myscriptname

  5. goto /etc/init.d

    cd /etc/init.d

  6. inclure dans la liste de démarrage avec une priorité de démarrage faible

    sudo update-rc.d myscriptname defaults 97 03

redémarrez votre ordinateur et vérifiez si le service a bien démarré

sudo ps -A --sort cmd

si votre service ne démarre pas correctement, vous devez d'abord vérifier s'il s'exécute lorsqu'il est appelé manuellement:

cd /etc/init.d
sudo service myscriptname start

ci-dessous j'inclus un exemple de fichier de service qui fonctionne réellement. comparez-le au service squelette afin de comprendre ce que vous devez configurer. NOTE: cela fonctionne sur l’implémentation classique d’AMS du cloud AWS EC2 d’Abuntun 12.04 (également sur Kubuntu 15.10).

#! /bin/sh
### BEGIN INIT INFO
# Provides:          
# Required-Start:    $remote_fs
# Required-Stop:     $remote_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: Sample_GT02 daemon startup script
# Description:       Sample Server for GT02 class 
### END INIT INFO

# Author: Tony Gil 
#

# Do NOT "set -e"

# PATH should only include /usr/* if it runs after the mountnfs.sh script
PATH=/sbin:/usr/sbin:/bin:/usr/bin
DESC="Sample Daemon"
NAME=sampleserver_gt02
DAEMON=/usr/sbin/$NAME
PIDFILE=/var/run/$NAME.pid
SCRIPTNAME=/etc/init.d/$NAME
CHUID=root

# Exit if the package is not installed
[ -x "$DAEMON" ] || exit 0

# Read configuration variable file if it is present
[ -r /etc/default/$NAME ] && . /etc/default/$NAME

# Load the VERBOSE setting and other rcS variables
. /lib/init/vars.sh

# Define LSB log_* functions.
# Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
. /lib/lsb/init-functions

#
# Function that starts the daemon/service
#
do_start()
{
   # Return
   #   0 if daemon has been started
   #   1 if daemon was already running
   #   2 if daemon could not be started
   start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
      || return 1
   start-stop-daemon --start --quiet --chuid $CHUID --pidfile $PIDFILE --exec $DAEMON -- \
      $DAEMON_ARGS \
      || return 2
}

#
# Function that stops the daemon/service
#
do_stop()
{
   # Return
   #   0 if daemon has been stopped
   #   1 if daemon was already stopped
   #   2 if daemon could not be stopped
   #   other if a failure occurred
   start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
   RETVAL="$?"
   [ "$RETVAL" = 2 ] && return 2
   # Wait for children to finish too if this is a daemon that forks
   # and if the daemon is only ever run from this initscript.
   # If the above conditions are not satisfied then add some other code
   # that waits for the process to drop all resources that could be
   # needed by services started subsequently.  A last resort is to
   # sleep for some time.
   start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
   [ "$?" = 2 ] && return 2
   # Many daemons don't delete their pidfiles when they exit.
   rm -f $PIDFILE
   return "$RETVAL"
}

#
# Function that sends a SIGHUP to the daemon/service
#
do_reload() {
   #
   # If the daemon can reload its configuration without
   # restarting (for example, when it is sent a SIGHUP),
   # then implement that here.
   #
   start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
   return 0
}

case "" in
  start)
   [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
   do_start
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  stop)
   [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
   do_stop
   case "$?" in
      0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
      2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
   esac
   ;;
  #reload|force-reload)
   #
   # If do_reload() is not implemented then leave this commented out
   # and leave 'force-reload' as an alias for 'restart'.
   #
   #log_daemon_msg "Reloading $DESC" "$NAME"
   #do_reload
   #log_end_msg $?
   #;;
  restart|force-reload)
   #
   # If the "reload" option is implemented then remove the
   # 'force-reload' alias
   #
   log_daemon_msg "Restarting $DESC" "$NAME"
   do_stop
   case "$?" in
     0|1)
      do_start
      case "$?" in
         0) log_end_msg 0 ;;
         1) log_end_msg 1 ;; # Old process is still running
         *) log_end_msg 1 ;; # Failed to start
      esac
      ;;
     *)
        # Failed to stop
      log_end_msg 1
      ;;
   esac
   ;;
  *)
   #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
   echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
   exit 3
   ;;
esac

:
    
réponse donnée tony gil 15.09.2012 - 19:13
la source
8

Faites une copie de /etc/init.d/skeleton et éditez-le aux endroits appropriés pour démarrer / arrêter / redémarrer votre service. Il est très bien commenté, vous devriez donc être capable de créer un script init.d en un rien de temps.

    
réponse donnée phuihock 18.04.2011 - 05:09
la source
2
  • Ajoutez vos commandes à /etc/rc.local
  • Pour que votre démon démarre automatiquement au démarrage du système.
réponse donnée karthick87 25.12.2010 - 11:39
la source
1

pleaserun est un script ruby ​​qui tente de résoudre le problème de la création automatique d'un script d'initialisation avec une seule commande. en citant sa page:

"Avec pleaserun, vous pouvez générer les lanceurs / scripts / peu importe:

lanced



systemd
runit
sysv init "

Il détecte également le système d’initialisation utilisé pour générer le script en conséquence.

    
réponse donnée Costin Gușă 17.09.2014 - 00:31
la source

Lire d'autres questions sur les étiquettes